# Class AbstractBidiMapDecorator<K,V>

java.lang.Object
org.apache.commons.collections4.map.AbstractIterableMap<K,V>
org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Map<K,V>`, `BidiMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `Put<K,V>`

Direct Known Subclasses:
  `AbstractOrderedBidiMapDecorator`, `UnmodifiableBidiMap`

public abstract class AbstractBidiMapDecorator<K,V> extends AbstractMapDecorator<K,V> implements BidiMap<K,V>
Provides a base decorator that enables additional functionality to be added to a BidiMap via decoration.

Methods are forwarded directly to the decorated map.

This implementation does not perform any special processing with the map views. Instead it simply returns the set/collection from the wrapped map. This may be undesirable, for example if you are trying to write a validating implementation it would provide a loophole around the validation. But, you might want that loophole, so this class is kept simple.

Since:
  3.0

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K,V>`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractBidiMapDecorator(BidiMap<K,V> map)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected BidiMap<K,V>`
  `decorated()`
  Gets the map being decorated.
  `K`
  `getKey(Object value)`
  Gets the key that is currently mapped to the specified value.
  `BidiMap<V,K>`
  `inverseBidiMap()`
  Gets a view of this map where the keys and values are reversed.
  `MapIterator<K,V>`
  `mapIterator()`
  Obtains a `MapIterator` over the map.
  `K`
  `removeValue(Object value)`
  Removes the key-value pair that is currently mapped to the specified value (optional operation).
  `Set<V>`
  `values()`
  Gets a a collection view of the values contained in this map.

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

  `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.BidiMap

  `put`

  ### Methods inherited from interface org.apache.commons.collections4.Get

  `containsKey, containsValue, entrySet, get, isEmpty, keySet, remove, size`

  ### Methods inherited from interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, get, getOrDefault, hashCode, isEmpty, keySet, merge, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

  ### Methods inherited from interface org.apache.commons.collections4.Put

  `clear, putAll`

- ## Constructor Details

  - ### AbstractBidiMapDecorator

    protected AbstractBidiMapDecorator(BidiMap<K,V> map)
    Constructor that wraps (not copies).
    Parameters:
      `map` - the map to decorate, must not be null
    Throws:
      `NullPointerException` - if the collection is null

- ## Method Details

  - ### decorated

    protected BidiMap<K,V> decorated()
    Gets the map being decorated.
    Overrides:
      `decorated` in class `AbstractMapDecorator<K,V>`
    Returns:
      the decorated map

  - ### getKey

    public K getKey(Object value)
    Description copied from interface: `BidiMap`
    Gets the key that is currently mapped to the specified value.

    If the value is not contained in the map, `null` is returned.

    Implementations should seek to make this method perform equally as well as `get(Object)`.

    Specified by:
      `getKey` in interface `BidiMap<K,V>`
    Parameters:
      `value` - the value to find the key for
    Returns:
      the mapped key, or `null` if not found

  - ### inverseBidiMap

    public BidiMap<V,K> inverseBidiMap()
    Description copied from interface: `BidiMap`
    Gets a view of this map where the keys and values are reversed.

    Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

    Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

    Specified by:
      `inverseBidiMap` in interface `BidiMap<K,V>`
    Returns:
      an inverted bidirectional map

  - ### mapIterator

    public MapIterator<K,V> mapIterator()
    Description copied from class: `AbstractIterableMap`
    Obtains a `MapIterator` over the map.

    A map iterator is an efficient way of iterating over maps. There is no need to access the entry set or use Map Entry objects.

         IterableMap<String,Integer> map = new HashedMap<String,Integer>();
         MapIterator<String,Integer> it = map.mapIterator();
         while (it.hasNext()) {
           String key = it.next();
           Integer value = it.getValue();
           it.setValue(value + 1);
         }

    Specified by:
      `mapIterator` in interface `IterableGet<K,V>`
    Overrides:
      `mapIterator` in class `AbstractIterableMap<K,V>`
    Returns:
      a map iterator

  - ### removeValue

    public K removeValue(Object value)
    Description copied from interface: `BidiMap`
    Removes the key-value pair that is currently mapped to the specified value (optional operation).

    If the value is not contained in the map, `null` is returned.

    Implementations should seek to make this method perform equally as well as `remove(Object)`.

    Specified by:
      `removeValue` in interface `BidiMap<K,V>`
    Parameters:
      `value` - the value to find the key-value pair for
    Returns:
      the key that was removed, `null` if nothing removed

  - ### values

    public Set<V> values()
    Description copied from interface: `Get`
    Gets a a collection view of the values contained in this map.
    Specified by:
      `values` in interface `BidiMap<K,V>`
    Specified by:
      `values` in interface `Get<K,V>`
    Specified by:
      `values` in interface `Map<K,V>`
    Overrides:
      `values` in class `AbstractMapDecorator<K,V>`
    Returns:
      a collection view of the values contained in this map.
    See Also:
      - `Map.values()`